@echo off
AT > nul
set tenant=%1
set email=%2
set ticket=%3
set clean=%4
set stop=%5
set version=8
if "%tenant%" == "/help" (
	echo =======================================
	echo   Perimeter 81 Log Collector v.%version% 
	echo =======================================
	echo. 
	echo Regular Use:
	echo ----------------------------
	echo p81_support_infor_v%version%.bat == Regular use with no attributes and flags ^(script must be run as Administrator^)
	echo. 
	echo Supported pre-populated attributes and flags:
	echo ----------------------------
	echo p81_support_infor_v%version%.bat ^<TENANT_NAME^> ^<USER_EMAIL^> ^<TICKET_NUMBER^> ^<CLEAN_FILES^> ^<SILENT^>
	echo 
	echo    ^<TENANT_NAME^>   - Mandatory - The workspace to which you're connecting ^(^<TENANT_NAME^>.perimeter81.com^)
	echo    ^<USER_EMAIL^>    - Mandatory - Your email address ^(preferably the one that you use to login to the platform^)
	echo    ^<TICKET_NUMBER^> - The support ticket number for the issue ^(if you got it from our team^). If set to 0 a new ticket will be created.
	echo    ^<CLEAN_FILES^>   - ^(Y/n^) - Delete generated files from the local machine once finished. Field is case-sensetive.
	echo    ^<SILENT^>        - Optional - S will run the script with no stops
	echo. 
	echo Example:
	echo ========
	echo \p81_support_infor_v%version%.bat internal user@email.com 0 Y S
	echo. 
	pause
	exit
)

:check_Permissions
    net session >nul 2>&1
    if %errorLevel% == 0 (
        goto isadministrator
    ) else (
        echo Script isn't running with Administrator privileges. Please right-click on the file and click 'Run as Administrator'
    )
pause
exit

:isadministrator
echo .
echo ...............PERIMETER 81...............
echo .                                        .
echo .  MMMMMMMMMMMMMMWXOkOKWMMMMMMMMMMMMMMM  . =================================================
echo .  MMMMMMMMMMMN0koc:::cox0NWMMMMMMMMMMM  . Perimeter 81 Log Collector script v. %version%
echo .  MMMMMMMWXOxlc:cccccc:::ldOKWMMMMMMMM  . =================================================
echo .  MMMMNKkoc::cccccclccccc:::cox0NMMMMM  . This script collects logs from %COMPUTERNAME% and sends
echo .  MW0xlc::ccccclok0K0kdlc:cc::::ld0WMM  . them to Perimeter 81 Support.
echo .  MKl:ccccccldOKXNNNNNNKkdlc::::::c0MM  . All required information will be collected, zipped and password protected.
echo .  M0l:cc:cdOXNNNNNNNNNNNNNXOdc::::cOMM  . 
echo .  M0l:cc:lOKKXNNNNNNNNNNNXK0kc::::cOMM  . By running the script you consent providing the collected data to the
echo .  M0l:c::ckK00KKXNNNNXK0OOkkxc::::cOMM  . Perimeter 81 team for troubleshooting and tracking purposes.
echo .  M0l::::ckK000000KK0OOkkkkkxc::::cOMM  . Please don't close the command line until a ticket number is provided.
echo .  M0l::::ckK0K000000OOOkkkkkdc::::cOMM  .
echo .  M0c::::cOKKKK00000Okkkkkxkdc:::::OMM  . Thank you for taking the time to provide us with the logs.
echo .  M0c:::::lxO0KK0000kkkkkxdoc::::::OMM  .
echo .  M0c::::::::ldk0K0Okkxdlc::::::::c0MM  . For any issues with the script please contact support@perimeter81.com.
echo .  M0c:::::::::::coxxoc::::::::::lxKWMM  .
echo .  M0c:::::::::::::::::::::::cdkKNMMMMM  .
echo .  M0c::::ldkxo:::::::::::lxOXWMMMMMMMM  . Best Regards,
echo .  M0c:ok0NWMMNKkdc:::cokKNMMMMMMMMMMMM  .
echo .  MN0KWMMMMMMMMMWX0O0XWMMMMMMMMMMMMMMM  . The Perimeter 81 team
echo .                                        .
echo ...........support@perimeter81.com........ ***SCRIPT MAY TAKE UP TO 5 MIN. TO RUN***
echo. 
echo.
if [%stop%] == [] set stop="N"
if %stop%==S (
	set "stop=echo."
) else (
	set "stop=pause"
)
%stop%
if [%ticket%] == [] SET /P ticket=Please provide your support ticket number ^(Optional^): 
echo.
if [%ticket%] == [] (
		set ticket="0"
) else (
		echo.
		echo ===================================================
		echo  Recorded support reference %ticket%
		echo ===================================================
		echo.
)
if [%tenant%] == [] set /P tenant=Please provide your tenant name ^(TENANT.perimeter81.com^): 
if [%tenant%] == [] (
		echo Tenant can't be empty
		pause
		exit
) else (
		echo.
		echo ===================================================
		echo  Recorded tenant %tenant%.perimeter81.com
		echo ===================================================
		echo.
)
if [%email%] == [] set /P email=Please provide your Perimeter 81 Username ^(registered email address^): 
if [%email%] == [] (
		echo Username can't be empty
		pause
		exit
) else (
		echo.
		echo ==========================================
		echo  Recorded username %email%
		echo ==========================================
		echo.
)

echo. && echo Generating timestamp and preparing the output directory...

for /f "tokens=*" %%a in ('powershell "get-date -format yyyyMMddHHmmss"') DO SET timestamp=%%a
FOR /F "usebackq" %%i IN (`hostname`) DO SET pcname=%%i
SET infoDir="%~dp0p81_info_v3_%pcname%_%timestamp%"
SET "binDir=%~dp0bin"
SET main=%~dp0
mkdir %infoDir%
echo Output directory is ready: %infoDir% 

echo %version% > %infoDir%\collect_script_version.txt

echo. && echo Gathering application logs..
mkdir %infoDir%\applogs
mkdir %infoDir%\applogs\service
mkdir %infoDir%\applogs\service32
mkdir %infoDir%\applogs\wer
echo %ver% >> %infoDir%\copied_logs.txt
echo. >> %infoDir%\copied_logs.txt
"%binDir%"\WireguardLogReader45.exe
move wireguardlog.txt %infoDir%
copy /Y wireguardlog.txt %infoDir%\applogs >> %infoDir%\copied_logs.txt
copy /Y "%LOCALAPPDATA%"\Perimeter81\Log\* %infoDir%\applogs >> %infoDir%\copied_logs.txt
copy /Y "%LOCALAPPDATA%"\Perimeter81\Updates\*.log %infoDir%\applogs >> %infoDir%\copied_logs.txt
dir "%LOCALAPPDATA%"\Perimeter81\Updates > %infoDir%\updates_folder.txt
copy /Y "%WINDIR%"\System32\config\systemprofile\AppData\Local\Perimeter81\Log\* %infoDir%\applogs\service >> %infoDir%\copied_logs.txt
copy /Y "%WINDIR%"\SysWOW64\config\systemprofile\AppData\Local\Perimeter81\Log\* %infoDir%\applogs\service32 >> %infoDir%\copied_logs.txt
copy /Y "%PROGRAMDATA%"\Perimeter81\Log\* %infoDir%\applogs >> %infoDir%\copied_logs.txt
copy /Y "%LOCALAPPDATA%"\Perimeter81\perimeter81_settings_new.xml %infoDir%\applogs >> %infoDir%\copied_logs.txt
copy /Y "%PROGRAMDATA%"\Perimeter81\perimeter81_settings_new.xml %infoDir%\applogs >> %infoDir%\copied_logs.txt
copy /Y "%LOCALAPPDATA%"\Perimeter81\*.conf %infoDir%\applogs >> %infoDir%\copied_logs.txt
copy /Y "%PROGRAMDATA%"\Perimeter81\*.conf %infoDir%\applogs >> %infoDir%\copied_logs.txt
copy /Y "%PROGRAMDATA%"\Microsoft\Windows\WER\ReportQueue\AppCrash_Perimeter81*.* %infoDir%\applogs\wer >> %infoDir%\copied_logs.txt
echo Gathering info on OS Group Policies...
whoami > %infoDir%\whoami.txt
set /p user=< %infoDir%\whoami.txt
gpresult /user "%user%" /v > %infoDir%\group_policies.txt
echo Running PING to www.perimeter81.com...
ping www.perimeter81.com > %infoDir%\ping-perimeter81.txt
echo finished.
echo Running PING to %tenant%.perimeter81.com...
ping %tenant%.perimeter81.com > %infoDir%\ping-%tenant%.perimeter81.com.txt
echo finished.
echo.
echo Gathering info on routes and ipconfig...
route print >> %infoDir%\routeprint.txt
ipconfig /all >> %infoDir%\ipconfig.txt
netstat -rn >> %infoDir%\routing-table.txt
"%PROGRAMFILES%"\"Perimeter 81"\bin\wg >> %infoDir%\wg-status.txt

echo Checking TCP ports 5050, 1195, 8443
"%binDir%"\Ncat\Ncat.exe -vz sdp.pzero.perimeter81.com 5050 >> %infoDir%\Ncat.txt 2>&1
"%binDir%"\Ncat\Ncat.exe -vz 37.139.26.109 1195 >> %infoDir%\Ncat.txt 2>&1
"%binDir%"\Ncat\Ncat.exe -vz 37.139.26.109 8443 >> %infoDir%\Ncat.txt 2>&1
echo Checking UDP ports 8055, 4500, 1194, 636, 500
"%binDir%"\Ncat\Ncat.exe -v -u -z -w 2 37.139.26.109 8055 >> %infoDir%\Ncat.txt 2>&1
"%binDir%"\Ncat\Ncat.exe -v -u -z -w 2 37.139.26.109 1194 >> %infoDir%\Ncat.txt 2>&1
"%binDir%"\Ncat\Ncat.exe -v -u -z -w 2 37.139.26.109 636 >> %infoDir%\Ncat.txt 2>&1
"%binDir%"\Ncat\Ncat.exe -v -u -z -w 2 37.139.26.109 4500 >> %infoDir%\Ncat.txt 2>&1
"%binDir%"\Ncat\Ncat.exe -v -u -z -w 2 37.139.26.109 500 >> %infoDir%\Ncat.txt 2>&1
echo Generating sleep study and sleep diagnostics reports...
powercfg /sleepstudy >> %infoDir%\sleepstudy.html
powercfg /systemsleepdiagnostics >> %infoDir%\systemsleepdiagnostics.html
powercfg /availablesleepstates >> %infoDir%\availablesleepstates.html
copy /Y sleepstudy-report.html %infoDir%\sleepstudy-report.html
copy /Y system-sleep-diagnostics.html %infoDir%\system-sleep-diagnostics.html
echo Exporting Application and System event logs...
wevtutil export-log System %infoDir%\System.evtx
wevtutil export-log Application %infoDir%\Application.evtx
echo Exporting HKLM\SYSTEM\CurrentControlSet\Control\Power registry key. This is mostly to check for Connected Standby (CsEnabled) and Modern Standby (ModernSleep)...
reg export HKLM\SYSTEM\CurrentControlSet\Control\Power %infoDir%\power.reg
echo Listing running processes...
powershell Get-Process > %infoDir%\processes.txt
echo Listing services and drivers...
sc.exe query > %infoDir%\services_and_drivers.txt
echo Listing OS updates..
wmic qfe list brief > %infoDir%\os_updates.txt
echo Checking P81 service command line...
wmic process where name="Perimeter81.Service.exe" get CommandLine > %infoDir%\p81svc_command_line.txt
move *.html %infoDir%
popd
echo Compressing all collected files...
"%binDir%\7zip\7za.exe" a -v3m -t7z -m0=lzma2 -mx=9 -mfb=64 -md=32m -ms=on -mhe=on -p%timestamp% "%main%%timestamp%-P81-Logs.7z" -r %infoDir%
echo finished.

set /A count=0
for %%x in (%main%%timestamp%-P81-Logs.*) do set /a count+=1
set files=%count%
echo Posting %main%%timestamp%-P81-Logs.7z from tenant:%tenant% for ticket:%ticket% in %files% parts -- user:%email% machine:%COMPUTERNAME%
set /A count=1
set /A part=1

:ship
if %count% GTR %files% goto finalize
set part=\"part\":%count%, 
if %count% geq 10 (
	set sufix=%count%
) else (
	set sufix=0%count%
)

"%binDir%\curl\bin\curl.exe" --request POST -H "Content-Type: application/x-7z-compressed" --data-binary "@%main%%timestamp%-P81-Logs.7z.0%sufix%" https://ksr7tdm0ij.execute-api.us-east-2.amazonaws.com/v1/uploadmaclogs | "%binDir%\jq-win32.exe" .body.file_path > "%main%response.log"
set /p filepath= < "%main%response.log"
set filepath=%filepath:!=%
if %count%==1 set part=
set "payload={ \"email\^":\^"%email%\^", \^"ticket\^":%ticket%, \^"tenant\^":\^"%tenant%\^",%part%\^"filepath\^":\^"%filepath%\^", \^"filename\^":\^"LogFiles-%timestamp%-%COMPUTERNAME%.7z.0%sufix%\^" }"
echo "%payload%"
"%binDir%\curl\bin\curl.exe" -d "%payload%" -H "Content-Type: application/json" -X POST https://ksr7tdm0ij.execute-api.us-east-2.amazonaws.com/v1/ | "%binDir%\jq-win32.exe" .body.message > "%main%response.log"
set /p temp= < "%main%response.log"
set ticket=%temp:*#=%
set ticket=%ticket:~0,5%
set /A count=%count%+1
goto ship

:finalize
more "%-v8main%response.log"
if [%clean%] == [] set /P clean=Delete all temporary files^? ^(n/Y^):
if %clean%==Y (
	RD /S /Q "%infoDir%"
	del /q /f /s "%main%%timestamp%-P81-Logs.7*"
	%stop%
)
echo.
echo "Thank you and goodbye!"
%stop%
exit /b